package cp.gui;


import cp.*;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.sql.*;
import javax.swing.*;

public class ResultDlg extends JDialog {
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JPanel jPanel1 = new JPanel();
  private GridBagLayout gridBagLayout2 = new GridBagLayout();
  private JLabel jLabelWhite = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabelBlack = new JLabel();
  private JPanel jPanel2 = new JPanel();
  private GridBagLayout gridBagLayout3 = new GridBagLayout();
  private JLabel jLabel4 = new JLabel();
  private JTextField jTextFieldWhite = new JTextField();
  private JTextField jTextFieldBlack = new JTextField();
  private JLabel jLabel5 = new JLabel();
  private JPanel jPanel3 = new JPanel();
  private JButton jButtonSave = new JButton();
  private JButton jButtonClose = new JButton();
  private Game game;

  public ResultDlg() {
    super();
    jbInit();
  }
  
  public void set(Game game) {
    this.game = game;
    if (game != null) {
      Player player = game.getWhitePlayer();
      if (player != null) {
        jLabelWhite.setText(player.toString());
        jTextFieldWhite.setText(Double.toString(game.getResult().getWhiteScore()));
      }
      else {
        jLabelWhite.setText("");
        jTextFieldWhite.setText("");
      }
      player = game.getBlackPlayer();
      if (player != null) {
        jLabelBlack.setText(player.toString());
        jTextFieldBlack.setText(Double.toString(game.getResult().getBlackScore()));
      }
      else {
        jLabelBlack.setText("");
        jTextFieldBlack.setText("");
      }
    }
    pack();
  }

  public void jbInit() {
    this.setTitle("Stt pongresultat");
    this.setResizable(false);
    this.setModal(true);
    this.getContentPane().setLayout(gridBagLayout1);
    jPanel1.setLayout(gridBagLayout2);
    jLabelWhite.setText("Vit");
    jLabelWhite.setFont(new Font("Tahoma", 1, 11));
    jLabel2.setText("-");
    jLabel2.setFont(new Font("Tahoma", 1, 11));
    jLabelBlack.setText("Svart");
    jLabelBlack.setFont(new Font("Tahoma", 1, 11));
    jPanel2.setLayout(gridBagLayout3);
    jLabel4.setText("Resultat:");
    jTextFieldWhite.setColumns(3);
    jTextFieldBlack.setColumns(3);
    jLabel5.setText("-");
    jButtonSave.setText("Spara");
    jButtonSave.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonSave_actionPerformed();
        }
      });
    jButtonClose.setText("Avbryt");
    jButtonClose.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonClose_actionPerformed();
        }
      });
    jPanel1.add(jLabelWhite, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 5), 0, 0));
    jPanel1.add(jLabelBlack, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(3, 5, 0, 5), 0, 0));
    jPanel2.add(jLabel4, new GridBagConstraints(0, 0, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jTextFieldWhite, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jTextFieldBlack, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jLabel5, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 5), 0, 0));
    this.getContentPane().add(jPanel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 0, 0, 0), 0, 0));
    jPanel3.add(jButtonSave, null);
    jPanel3.add(jButtonClose, null);
    this.getContentPane().add(jPanel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    pack();
  }

  private void jButtonClose_actionPerformed() {
    this.setVisible(false);
  }

  private void jButtonSave_actionPerformed() {
    // Update result
    Result result = game.getResult();
    try {
      double whiteScore = Double.parseDouble(jTextFieldWhite.getText());
      double blackScore = Double.parseDouble(jTextFieldBlack.getText());
      double max = result.getPointsPerGame();
      if (whiteScore+blackScore > max) {
        JOptionPane.showMessageDialog(this, "Vits och svarts resultat fr ej verstiga maxpongen!", "Fel", JOptionPane.INFORMATION_MESSAGE);
        return;
      }
      result.setResultType(Result.ResultType.NO_RESULT);
      result.addWhiteScore(whiteScore);
      result.addBlackScore(blackScore);
      result.getGame().update();
      jButtonClose_actionPerformed();
    }
    catch (ChessPairerException e) {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Fel", JOptionPane.INFORMATION_MESSAGE);
    }
    catch (SQLException e) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }
}
