package cp.gui;

import cp.Player;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class SelectPlayerDialog extends JDialog {
  public enum SSFUpdateResult {OK, MISSING, ABORTED};
  private JScrollPane jScrollPane = new JScrollPane();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JLabel jLabel = new JLabel();
  private DefaultListModel listModel = new DefaultListModel();
  private JList jList = new JList(listModel);
  private JPanel jPanel1 = new JPanel();
  private JButton jButtonOk = new JButton();
  private JButton jButtonCancel = new JButton();
  private JButton jButtonMissing = new JButton();
  private SSFUpdateResult result = SSFUpdateResult.ABORTED;

  public SelectPlayerDialog(JDialog parent) {
    super(parent, "Vlj spelare", true);
    try {
      jbInit();
      this.setLocationRelativeTo(parent);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setSize( new Dimension( 300, 200 ) );
    this.getContentPane().setLayout(borderLayout1);
    this.setResizable(true);
    this.setModal(true);
    jScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
    jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jButtonOk.setText("Ok");
    jButtonOk.setSelected(true);
    jButtonOk.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonOk_actionPerformed();
        }
      });
    jButtonCancel.setText("Avbryt");
    jButtonCancel.setDefaultCapable(false);
    jButtonCancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonCancel_actionPerformed();
        }
      });
    jButtonMissing.setText("Spelaren saknas i listan");
    jButtonMissing.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonMissing_actionPerformed();
        }
      });
    jLabel.setText("Select player:");
    jScrollPane.getViewport().add(jList, null);
    this.getContentPane().add(jScrollPane, BorderLayout.CENTER);
    this.getContentPane().add(jLabel, BorderLayout.NORTH);
    jPanel1.add(jButtonOk, null);
    jPanel1.add(jButtonMissing, null);
    jPanel1.add(jButtonCancel, null);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
  }
  
  public int getPlayerIndex(Player player, JSONArray array) throws JSONException {
    result = SSFUpdateResult.ABORTED;
    listModel.clear();
    jLabel.setText("Vem r " + player.getFirstName() + " " + player.getLastName() + "?");
    for (int i=0; i<array.length(); i++) {
      JSONObject obj = array.getJSONObject(i);
      listModel.addElement(String.format("%s %s, %s, fdd %s", obj.getString("firstName"), obj.getString("lastName"), obj.getString("mainclub"), obj.getString("birthdate")));
    }
    this.setVisible(true);
    return jList.getSelectedIndex();
  }

  private void jButtonOk_actionPerformed() {
    if (jList.getSelectedIndex() > -1) {
      result = SSFUpdateResult.OK;
      setVisible(false);
    }
    else {
      JOptionPane.showMessageDialog(this, "Vlj en spelare innan du trycker p Ok.", "Meddelande", JOptionPane.INFORMATION_MESSAGE);
    }
  }

  private void jButtonCancel_actionPerformed() {
    result = SSFUpdateResult.ABORTED;
    setVisible(false);
  }

  private void jButtonMissing_actionPerformed() {
    result = SSFUpdateResult.MISSING;
    setVisible(false);
  }

  public SSFUpdateResult getResult() {
    return result;
  }
}
