package cp.gui.web;

import cp.ChessPairerException;
import cp.Round;
import cp.Tournament;
import cp.gui.AlphabeticalPairingPanel;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.swing.JOptionPane;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import org.w3c.dom.*;

public class HTMLAlphabeticalPairings extends HTMLPairings {
	private int columns;

	public HTMLAlphabeticalPairings(int columns) {
		this.columns = columns;
	}
  
  public void publish(AlphabeticalPairingPanel alphabeticalPairingPanel, int rows) throws FileNotFoundException, IOException {
    // Create output html file
    alphabeticalPairingPanel.update();
		Round round = alphabeticalPairingPanel.getRound();
		Tournament tournament = round.getTournament();
    String fileName = tournament.getResultsPage();
    if (fileName != null) {
      try {
        // Create document
        Document document = createDocument();
        Element html = document.createElement("html");
        document.appendChild(html);
        // Create title
        Element head = document.createElement("head");
        html.appendChild(head);
        Element title = document.createElement("title");
        head.appendChild(title);
        Text text = document.createTextNode("Alfabetisk lottning " + tournament);
        title.appendChild(text);
				appendStylesheet(document, head);
        // Create body
        Element body = document.createElement("body");
        html.appendChild(body);
        text = document.createTextNode("Lotta - Alfabetisk lottning fr turnering " + tournament + ", rond " + round.getRoundNr());
        body.appendChild(text);
        
        // Save the table
        alphabeticalPairingPanel.save(document, body, rows, columns);
        
        // Save the file
        save(document, fileName);
      }
      catch (ParserConfigurationException e) {
        JOptionPane.showMessageDialog(null, "ParserConfigurationException:" + e.getMessage(), "Kan inte skapa fil", JOptionPane.ERROR_MESSAGE);
      }
      catch (TransformerConfigurationException e) {
        JOptionPane.showMessageDialog(null, "Resultatfil kan inte ppnas eller skapas. Meddelande:" + e.getMessage(), "Kan inte ppna fil", JOptionPane.ERROR_MESSAGE);
      }
      catch (TransformerException e) {
        JOptionPane.showMessageDialog(null, "Resultatfil kan inte ppnas eller skapas. Meddelande:" + e.getMessage(), "Kan inte ppna fil", JOptionPane.ERROR_MESSAGE);
      }
			catch (ChessPairerException e) {
				JOptionPane.showMessageDialog(null, e.getMessage(), "Kan inte publicera fil", JOptionPane.INFORMATION_MESSAGE);
			}
    }
    else {
      JOptionPane.showMessageDialog(null, "Du mste ange ett namn fr html-filen i turneringsdialogen fr att kunna publicera den.", "Ingen html-fil specificerad", JOptionPane.INFORMATION_MESSAGE);
    }
  }
  
}
