package cp.tiebreak;

import cp.*;

import cp.Result.*;
import java.util.Vector;

public class TiebreakWins implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   */
  public double getTiebreak(Round round, Player player) {
    double tiebreak = 0;
		// For each opponent that has the same score, add the internal result.
    Vector games = player.getGames();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);
      if (game.getRoundNr() <= round.getRoundNr()) {
				if (!game.plays(null)) {
					Result result = game.getResult();
				  Player white = game.getWhitePlayer();
				  Player black = game.getBlackPlayer();
				  if (white == player) {
					  if (result.getResultType() == ResultType.WHITE_WIN || result.getResultType() == ResultType.WHITE_WIN_WO) {
							tiebreak++;
						}
					}
					else if (black == player) {
					  if (result.getResultType() == ResultType.BLACK_WIN || result.getResultType() == ResultType.BLACK_WIN_WO) {
					    tiebreak++;
					  }
					}
				}
      }
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Vinster";
  }

  public String getShortName() {
    return "Vin";
  }
  
  public String format(double value) {
    return Integer.toString((int) value);
  }
  
  
}
